'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbgametimer.exe"
#Dim All
#Debug Display On
#Debug Error On
%Unicode = 1
#Include "Win32API.inc"
#Include "cgdiplus.inc"

'#Resource Icon baseball, "images\baseball.ico"
#Resource Icon sports, "icons\sports.ico"
#Resource Icon xstart, "icons\start.ico"
#Resource Icon xstartb, "icons\startb.ico"
#Resource Icon xnew, "icons\new.ico"
#Resource Icon xhelp, "icons\help.ico"
#Resource Icon x1, "icons\1.ico"
#Resource Icon x3, "icons\3.ico"
#Resource Icon x5, "icons\5.ico"
#Resource Icon x1b, "icons\1b.ico"
#Resource Icon x3b, "icons\3b.ico"
#Resource Icon x5b, "icons\5b.ico"
#Resource Icon xswitch, "icons\switch.ico"
#Resource Icon xsong, "icons\music.ico"
#Resource Icon xlists, "icons\images.ico"
#Resource Icon xlistsb, "icons\imagesb.ico"

$Ver = "1.0"

Enum Equates Singular
   IDT_New = 500
   IDT_Start
   IDT_Time1
   IDT_Time3
   IDT_Time5
   IDT_Switch
   IDT_Anthem
   IDT_ShowLists
   IDT_Help
   IDC_Toolbar
   IDC_Graphic
   ID_Timer
   ID_TimerDelay

   IDC_NameAFG
   IDC_NameABG
   IDC_NameBFG
   IDC_NameBBG

   IDC_TotalScoreA
   IDC_TotalScoreB

   IDC_FrameA
   IDC_FrameB
   IDC_StatusBar
   IDC_ScoreA
   IDC_ScoreB
   IDC_ScoreC
   IDC_ScoreD
   IDC_ScoreE
   IDC_ScoreF
   IDC_ScoreG
   IDC_ScoreH
   IDC_ScoreI
   IDC_ScoreO
   IDC_ScoreP
   IDC_ScoreQ
   IDC_ScoreR
   IDC_ScoreS
   IDC_ScoreT
   IDC_ScoreU
   IDC_ScoreV
   IDC_ScoreW

   IDC_PeriodA
   IDC_PeriodB

   IDC_LabelA
   IDC_LabelB
   IDC_LabelPlayers
   IDC_LabelTeams
   IDC_NameAText
   IDC_NameBText

   IDC_ScoreAA  'updown control
   IDC_ScoreBB  'updown control
   IDC_ScoreCC  'updown control
   IDC_ScoreDD  'updown control
   IDC_ScoreEE  'updown control
   IDC_ScoreFF  'updown control
   IDC_ScoreGG  'updown control
   IDC_ScoreHH  'updown control
   IDC_ScoreII  'updown control

   IDC_ScoreOO  'updown control
   IDC_ScorePP  'updown control
   IDC_ScoreQQ  'updown control
   IDC_ScoreRR  'updown control
   IDC_ScoreSS  'updown control
   IDC_ScoreTT  'updown control
   IDC_ScoreUU  'updown control
   IDC_ScoreVV  'updown control
   IDC_ScoreWW  'updown control


   IDC_FaceA
   IDC_FaceB
   IDC_TeamA
   IDC_TeamB
   IDC_FaceList
   IDC_TeamList
   IDC_BorderA
   IDC_BorderB

   IDM_SelectSport
   IDM_ClearHistory
   IDM_Escape
   IDM_Test
   IDM_NoSound
   IDM_ScoreSound
   IDM_AllowDelays
   IDM_GameStatus
   IDM_SetDelayValues

   IDW_Label
End Enum

Type CustomColors
   c(15) As Long
End Type

Global hDlg,hWait As Dword
Global hFont,hFontS,hFontB,hFontM As Dword
Global hImage,hImageDC,hGraphic,hGraphicDC As Dword
Global hBMPBorder, hBMPBorderDC, hBorderADC, hBorderBDC As Dword
Global hFaceA, hFaceB As Dword
Global hTeamA, hTeamB As Dword
Global hFaceADC, hFaceBDC As Dword
Global hTeamADC, hTeamBDC As Dword
Global hFaceList, hTeamList As Dword   'Names of files

Global pImage, hImageList, hToolbar As Dword
Global Token, hDC, pGraphics As Dword
Global StartupInput As GdiplusStartupInput
Global CustomColorList As CustomColors

Global AllowDelays, ShowLists, MaxTime, PlayWave, DelayA, DelayB As Long
Global History(), SportName, GameStatus As WStringZ * %Max_Path
Global ActivePlayer, Periods, PeriodCount, DelayCount, NoSound As Long
Global Faces(), Teams() As String

Global NameAText, NameBText As WStringZ * %Max_Path
Global NameAFG, NameABG As Long
Global NameBFG, NameBBG As Long
Global TotalScoreA, TotalScoreB As Long
Global TeamAPos, TeamBPos As Long
Global FaceAPos, FaceBPos As Long
Global CurrentTimeA, CurrentTimeB As Long
Global ScoreA, ScoreB, ScoreC, ScoreD, ScoreE, ScoreF, ScoreG, ScoreH, ScoreI As Long
Global ScoreO, ScoreP, ScoreQ, ScoreR, ScoreS, ScoreT, ScoreU, ScoreV, ScoreW As Long

Function PBMain() As Long
   Local w,h As Long

   StartupInput.GdiplusVersion = 1                  ' Initialize GDI+
   GdiplusStartup(Token, StartupInput, ByVal %NULL) ' Initialize GDI+
   GdipCreateFromHDC(hDC, pGraphics)                 'create graphic object

   Dialog New Pixels, 0, "gbGameTimer   v" + $Ver,200,200,820,1000, %WS_OverlappedWindow Or %WS_ClipSiblings Or %WS_ClipChildren To hDlg
   Dialog Set Icon  hDlg, "sports"

   Control Add ComboBox, hDlg, %IDC_LabelTeams, , 25,470,150,250 '<-- places here to get preferred TAB order

   'Toolbar
   CreateToolbar

'   'TeamA ================================================================================
   Control Add Frame, hDlg, %IDC_FrameA,"Player 1", 20,105,465,200, %BS_Left Or %BS_Top, %WS_Ex_Transparent
   Control Add ComboBox, hDlg, %IDC_NameAText, , 40,145,150,200
   Control Add Label, hDlg, %IDC_PeriodA,"" , 35,205,40,5
   Control Set Color hDlg, %IDC_PeriodA, %Red, %Red
'
   Control Add Graphic, hDlg, %IDC_FaceA,"",225,170,64,64, %SS_Notify 'or %WS_Border
   Control Handle hDlg, %IDC_FaceA To hFaceA
   Graphic Attach hDlg, %IDC_FaceA
   Graphic Get DC To hFaceADC
'
   Control Add Graphic, hDlg, %IDC_TeamA,"",315,170,64,64, %SS_Notify 'or %WS_Border
   Control Handle hDlg, %IDC_TeamA To hTeamA
   Graphic Attach hDlg, %IDC_TeamA
   Graphic Get DC To hTeamADC

   Control Add Label, hDlg, %IDC_TotalScoreA, "0", 405,170,50,45, %SS_Notify Or %WS_Border Or %SS_Center Or %SS_CenterImage
   Control Add Label, hDlg, %IDC_NameAFG, "", 405,220,20,15, %SS_Notify Or %WS_Border
   Control Add Label, hDlg, %IDC_NameABG, "", 435,220,20,15, %SS_Notify Or %WS_Border

   Control Add Label, hDlg, %IDC_LabelA, "Player  Team  Score", 220,125,250,40, %SS_Notify 'or %WS_Border

'   'TeamB ================================================================================
   Control Add Frame, hDlg, %IDC_FrameB,"Player 2", 505,105,465,200, %BS_Left Or %BS_Top, %WS_Ex_Transparent
   Control Add ComboBox, hDlg, %IDC_NameBText, , 525,145,150,200
   Control Add Label, hDlg, %IDC_PeriodB,"" , 525,205,40,5
   Control Set Color hDlg, %IDC_PeriodB, %Red, %Red
'
   Control Add Graphic, hDlg, %IDC_FaceB,"",705,170,64,64, %SS_Notify 'or %WS_Border
   Control Handle hDlg, %IDC_FaceB To hFaceB
   Graphic Attach hDlg, %IDC_FaceB
   Graphic Get DC To hFaceBDC

   Control Add Graphic, hDlg, %IDC_TeamB,"",800,170,64,64, %SS_Notify 'or %WS_Border
   Control Handle hDlg, %IDC_TeamB To hTeamB
   Graphic Attach hDlg, %IDC_TeamB
   Graphic Get DC To hTeamBDC

   Control Add Label, hDlg, %IDC_TotalScoreB, "0", 885,170,50,45, %SS_Notify Or %WS_Border Or %SS_Center Or %SS_CenterImage
   Control Add Label, hDlg, %IDC_NameBFG, "", 885,220,20,15, %SS_Notify Or %WS_Border
   Control Add Label, hDlg, %IDC_NameBBG, "", 915,220,20,15, %SS_Notify Or %WS_Border

   Control Add Label, hDlg, %IDC_LabelB, "Player  Team  Score", 700,125,250,40, %SS_Notify 'or %WS_Border

'   'Player/Team label ===================================================================
'
'   'Border (graphical divider) ===========================================================
   LoadImageToMemoryBitmap Exe.Path$ + "images\borderb.gif", hBMPBorder, w,h, hBMPBorderDC
   Control Add Graphic, hDlg, %IDC_BorderA,"",160,550,590,50, %SS_Notify 'or %WS_Border
   Graphic Attach hDlg, %IDC_BorderA
   Graphic Get DC To hBorderADC
   TransparentBlt hBorderADC,0,0,w,h,hBMPBorderDC,0,0,w,h,%Black

   Control Add Graphic, hDlg, %IDC_BorderB,"",160,305,590,50, %SS_Notify 'or %WS_Border
   Graphic Attach hDlg, %IDC_BorderB
   Graphic Get DC To hBorderBDC
   TransparentBlt hBorderBDC,0,0,w,h,hBMPBorderDC,0,0,w,h,%Black
'
'   'Face/Team Image Selection Sheets ====================================================
   Control Add Label, hDlg, %IDC_LabelPlayers, "Players", 25,370,85,40, %SS_Notify
   Control Add Graphic, hDlg, %IDC_FaceList,"",120,355,780,89, %SS_Notify Or %WS_Border, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_FaceList To hFaceList

   ComboBox Insert hDlg, %IDC_LabelTeams, 1, "Baseball"
   ComboBox Insert hDlg, %IDC_LabelTeams, 1, "Basketball"
   ComboBox Insert hDlg, %IDC_LabelTeams, 1, "Football"
   ComboBox Insert hDlg, %IDC_LabelTeams, 1, "Hockey"
   ComboBox Insert hDlg, %IDC_LabelTeams, 1, "Soccer"

   Control Add Graphic, hDlg, %IDC_TeamList,"",180,455,720,89, %SS_Notify Or %WS_Border, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_TeamList To hTeamList

   'Main game graphic controls ==========================================================
   Control Add Graphic, hDlg, %IDC_Graphic,"", 0,590,910,180, %SS_Notify 'or %WS_Border
   Control Handle hDlg, %IDC_Graphic To hGraphic

   Control Add Statusbar, hDlg, %IDC_Statusbar, "Welcome to gbGameTimer!",0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local i,x,y,w,h,iPos As Long, pt As Point, temp$
   Local PTT As ToolTipText Ptr

   Select Case Cb.Msg
      Case %WM_InitDialog
         ReDim History(9)   '0-4 is 5-9 is B
         SettingsINI "get"
         BuildAcceleratorTable

         Control Set Text hDlg, %IDC_NameAText, NameAText
         Control Set Text hDlg, %IDC_NameBText, NameBText
         Control Set Text hDlg, %IDC_LabelTeams, SportName

         SetPeriods
         CreateScoreBoxes

         LoadTeamImages
         LoadFaceImages
         LoadSounds
         Control Set Color hDlg, %IDC_TotalScoreA, NameAFG, NameABG
         Control Set Color hDlg, %IDC_TotalScoreB, NameBFG, NameBBG

         LoadSingleFaceImage FaceAPos, hFaceADC
         LoadSingleFaceImage FaceBPos, hFaceBDC
         LoadSingleTeamImage TeamAPos, hTeamADC
         LoadSingleTeamImage TeamBPos, hTeamBDC

         Graphic Attach hDlg, %IDC_Graphic, ReDraw
         Graphic Get DC To hGraphicDC
         LoadImageToMemoryBitmap Exe.Path$ + "images\" + SportName + ".png", hImage, w,h, hImageDC
         Graphic Attach hDlg, %IDC_Graphic, ReDraw
         BuildFonts
         RestoreControlValues
         ResetToolbarImages
         BuildPlayerMRU(0)
         DisplayListControls
         HidePeriod
         ColorActivePlayer
         DrawGameBackGround
         SetMenusAndToolbar
         If GameStatus = "On" Then SetTimer hDlg, %ID_Timer, 1000, ByVal(%Null)
         Control Set Focus hDlg, %IDC_NameAText

      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_FaceList,w-140,89
         Control Set Size hDlg, %IDC_TeamList,w-195,89

      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         GetScores
         SettingsINI "save"
         'shutdown GDI
         If pImage Then GdipDisposeImage(pImage)            'cleanup
         If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
         GdiplusShutdown token                              'shutdown GDI+

      Case %WM_LButtonDblClk
         pt.x = Get_x_LParam(Cb.LParam)
         pt.y = Get_y_LParam(Cb.LParam)
         Select Case ChildWindowFromPoint(hDlg,pt)
            Case GetDlgItem(hDlg, %IDC_FrameA)
               ActivePlayer = 1
               ColorActivePlayer
               DrawGameBackGround
            Case GetDlgItem(hDlg, %IDC_FrameB)
               ActivePlayer = 2
               ColorActivePlayer
               DrawGameBackGround
         End Select

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_SetDelayValues
               Dialog Get Loc hDlg To x,y
               temp$ = InputBox$("Enter as seconds,minutes" + $CrLf + $CrLf + "ss = sec between players" + $CrLf + "mm = min between periods", "Time Delays", Str$(DelayA) + "," + Str$(DelayB), x+300,y+300)
               If Len(temp$) Then
                  DelayA =   Val(Parse$(temp$,",",1))
                  DelayB =   Val(Parse$(temp$,",",2))
               End If

            Case %IDC_LabelPlayers
               If Cb.CtlMsg = %Stn_Clicked Then DisplayGameStatus

            Case %IDM_AllowDelays
               AllowDelays = AllowDelays Xor 1
               ReadText IIf$(AllowDelays, "Delays are ON", "Delays are OFF")

            Case %IDM_GameStatus
               DisplayGameStatus

            Case %IDC_Graphic
               Select Case Cb.CtlMsg
                  Case %STN_DblClk
                     If ActivePlayer = 1 Then CurrentTimeA = MaxTime - 1
                     If ActivePlayer = 2 Then CurrentTimeB = MaxTime - 1
               End Select
            Case %IDT_ShowLists
               ShowLists = ShowLists Xor 1
               ResetToolbarImages
               SetMenusAndToolbar
               DisplayListControls

            Case %IDM_NoSound
               NoSound = NoSound Xor 1
               ReadText "zSound has been turned " + IIf$(NoSound,"off","on")

            Case %IDM_ScoreSound
               PlayScoreSound

            Case %IDM_Escape : Dialog End hWait

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbgametimer.htm"
               i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_ClearHistory
               BuildPlayerMRU(1)   '1=clear history
               ReadText "Name history has been cleared"

            Case %IDT_New
               KillTimer hDlg, %ID_Timer
               'start new game
               ClearValues :  RestoreControlValues
               'draw empty game
               DrawGameBackGround
               ResetToolbarImages
               SetMenusAndToolbar
               ReadText "New game of " + SportName

            Case %IDT_Start
               Select Case GameStatus
                  Case "Off"
                     'start new game
                     ClearValues :  RestoreControlValues
                     'add player names to History() and to ComboBox
                     BuildPlayerMRU(0)
                     'Draw empty game
                     DrawGameBackGround
                     GameStatus = "On"
                     ResetToolbarImages
                     SetMenusAndToolbar
                     ReadText "Game started"
                     SetTimer hDlg, %ID_Timer, 1000, ByVal(%Null)
                  Case "On"
                     KillTimer hDlg, %ID_Timer
                     GameStatus = "Pause"
                     ResetToolbarImages
                     SetMenusAndToolbar
                     ReadText "The game has been paused"
                  Case "Pause"
                     GameStatus = "On"
                     ResetToolbarImages
                     SetMenusAndToolbar
                     ReadText "The game has been re-started"
                     SetTimer hDlg, %ID_Timer, 1000, ByVal(%Null)
               End Select

            Case %IDM_SelectSport
               Select Case LCase$(SportName)
                  Case "baseball"   : SportName = "Basketball" : SetPeriods   'periods
                  Case "basketball" : SportName = "Football"   : SetPeriods   'quarters
                  Case "football"   : SportName = "Hockey"     : SetPeriods   'periods
                  Case "hockey"     : SportName = "Soccer"     : SetPeriods   'halves
                  Case "soccer"     : SportName = "Baseball"   : SetPeriods   'innings
               End Select
               DisplaySport

            Case %IDT_Anthem
               If PlayWave Then
                  PlayWave = 0
                  Play Wave End
               Else
                  Select Case SportName
                     Case "Baseball"   : temp$ = "sounds\baseball.wav"
                     Case "Basketball" : temp$ = "sounds\basketball.wav"
                     Case "Football"   : temp$ = "sounds\football.wav"
                     Case "Hockey"     : temp$ = "sounds\hockey.wav"
                     Case "Soccer"     : temp$ = "sounds\soccer.wav"
                  End Select
                  PlayWave = 1
                  Play Wave IIf$(IsFile(temp$), temp$, "sounds\anthem.wav")
               End If

            Case %IDT_Switch : SwitchSides : RestoreControlValues

            Case %IDT_Time1
               If Cb.CtlMsg = %BN_Clicked Then
                  KillTimer hDlg, %ID_Timer
                  If GameStatus = "On" Then ReadText "Game Cancelled"
                  GameStatus = "Off" : MaxTime = 60 : CurrentTimeA = 0 : CurrentTimeB = 0
                  ResetToolbarImages
                  SetMenusAndToolbar
                  Control ReDraw hDlg, %IDC_Toolbar
                  DrawGameBackground
                  ReadText "Each player now has 1 minute per. Press start to begin a new game."
               End If

            Case %IDT_Time3
               If Cb.CtlMsg = %BN_Clicked Then
                  KillTimer hDlg, %ID_Timer
                  If GameStatus = "On" Then ReadText "Game cancelled"
                  GameStatus = "Off" : MaxTime = 180  : CurrentTimeA = 0 : CurrentTimeB = 0
                  ResetToolbarImages
                  SetMenusAndToolbar
                  Control ReDraw hDlg, %IDC_Toolbar
                  DrawGameBackGround
                  ReadText "Each player now has 3 minutes. Press start to begin a new game."
               End If

            Case %IDT_Time5
               If Cb.CtlMsg = %BN_Clicked Then
                  KillTimer hDlg, %ID_Timer
                  If GameStatus="On" Then ReadText "Game cancelled"
                  GameStatus = "Off" : MaxTime = 300 : CurrentTimeA = 0  : CurrentTimeB = 0
                  ResetToolbarImages
                  SetMenusAndToolbar
                  Control ReDraw hDlg, %IDC_Toolbar
                  DrawGameBackGround
                  ReadText "Each player now has 5 minutes. Press start to begin a new game."
               End If

            Case %IDC_FaceList
               If Cb.CtlMsg = %Stn_Clicked Then
                  Graphic Attach hDlg, %IDC_FaceList
                  Graphic Get View To x,y
                  GetCursorPos pt
                  ScreenToClient hFaceList, pt
                  pt.x = pt.x + x
                  iPos = pt.x \ 80
                  If ActivePlayer=1 Then FaceAPos = iPos Else FaceBPos = iPos
                  Graphic Attach hDlg, IIf(ActivePlayer=1, %IDC_FaceA, %IDC_FaceB)
                  Graphic Clear
                  LoadSingleFaceImage(iPos,IIf(ActivePlayer=1,hFaceADC,hFaceBDC))
                  Graphic ReDraw
                  Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, StatusBarContent
               End If

            Case %IDC_TeamList
               If Cb.CtlMsg = %Stn_Clicked Then
                  Graphic Attach hDlg, %IDC_TeamList
                  Graphic Get View To x,y
                  GetCursorPos pt
                  ScreenToClient hTeamList, pt
                  pt.x = pt.x + x
                  iPos = pt.x \ IIf(SportName = "Hockey" Or SportName = "Football",100,80)
                  If ActivePlayer=1 Then TeamAPos = iPos Else TeamBPos = iPos
                  Graphic Attach hDlg, IIf(ActivePlayer=1, %IDC_TeamA, %IDC_TeamB)
                  Graphic Clear
                  LoadSingleTeamImage(iPos,IIf(ActivePlayer=1,hTeamADC,hTeamBDC))
                  Graphic ReDraw
                  Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, StatusBarContent
               End If

            Case %IDC_LabelTeams
               If Cb.CtlMsg = %CBN_SelChange Then
                  Control Send hDlg, %IDC_LabelTeams, %CB_GetCurSel, 0, 0 To i
                  ComboBox Get Text hDlg, %IDC_LabelTeams, i+1 To SportName
                  Control Set Text hDlg, %IDC_LabelTeams, SportName
                  DisplaySport
                  SetMenusAndToolbar
               End If

            Case %IDC_NameAText
               Select Case Cb.CtlMsg
                  Case %CBN_EditChange
                     DrawGameBackGround
                  Case %CBN_SelChange
                     Control Send hDlg, %IDC_NameAText, %CB_GetCurSel, 0, 0 To i
                     ComboBox Get Text hDlg, %IDC_NameAText, i+1 To NameAText
                     Control Set Text hDlg, %IDC_NameAText, NameAText
                     DrawGameBackGround
               End Select

            Case %IDC_NameBText
               Select Case Cb.CtlMsg
                  Case %CBN_EditChange
                     DrawGameBackGround
                  Case %CBN_SelChange
                     Control Send hDlg, %IDC_NameBText, %CB_GetCurSel, 0, 0 To i
                     ComboBox Get Text hDlg, %IDC_NameBText, i+1 To NameBText
                     Control Set Text hDlg, %IDC_NameBText, NameBText
                     DrawGameBackGround
               End Select

            Case %IDC_ScoreA To %IDC_ScoreW : If Cb.CtlMsg = %EN_Change Then BuildScore

            Case %IDT_New
               KillTimer hDlg, %ID_Timer
               GameStatus = "Off"
               ResetToolbarImages
               SetMenusAndToolbar
               CurrentTimeA = 0
               CurrentTimeB = 0
               ReadText "New game"

            Case %IDC_NameAFG
               NameAFG = SelectColor(NameAFG)
               Control Set Color hDlg, %IDC_NameAFG, %Black, NameAFG
               Control ReDraw hDlg, %IDC_NameAFG
               DrawGameBackGround

            Case %IDC_NameABG
               NameABG = SelectColor(NameABG)
               Control Set Color hDlg, %IDC_NameABG, %Black, NameABG
               Control ReDraw hDlg, %IDC_NameABG
               DrawGameBackGround

            Case %IDC_NameBFG
               NameBFG = SelectColor(NameBFG)
               Control Set Color hDlg, %IDC_NameBFG, %Black, NameBFG
               Control ReDraw hDlg, %IDC_NameBFG
               DrawGameBackGround

            Case %IDC_NameBBG
               NameBBG = SelectColor(NameBBG)
               Control Set Color hDlg, %IDC_NameBBG, %Black, NameBBG
               Control ReDraw hDlg, %IDC_NameBBG
               DrawGameBackGround
         End Select

      Case %WM_Notify
         If Cb.NmCode = %TTN_GetDispInfo Then
            PTT = Cb.LParam
            @PTT.@lpszText = SetToolTips(Cb.NmId)
         End If

      Case %WM_Timer
         Select Case Cb.Ctl
            Case %ID_Timer
               DrawGameBackGround
               DrawGame
            Case %ID_TimerDelay
               PrintDelayMessage
               Decr DelayCount
               If DelayCount = 0 Then Dialog End hWait
         End Select
   End Select
End Function

Function SettingsINI(task$) As Long   'gbVisualDesigner function
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1005", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "860", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "NameA", "Dado", NameAText, %Max_Path, INIFileName
      Getprivateprofilestring "All", "NameB", "Daniel", NameBText, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SportName", "Baseball", SportName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "GameStatus", "Off", GameStatus, %Max_Path, INIFileName

      For x = 0 To 9
         Getprivateprofilestring "History", "History" + Format$(x,"0"), "", History(x), %Max_Path, INIFileName
      Next x

      'get value for numeric variables
      Getprivateprofilestring "All", "NameAFG", Str$(%Yellow), temp, %Max_Path, INIFileName:  NameAFG = Val(temp)
      Getprivateprofilestring "All", "NameABG", Str$(%Blue), temp, %Max_Path, INIFileName:  NameABG = Val(temp)
      Getprivateprofilestring "All", "NameBFG", Str$(%Red), temp, %Max_Path, INIFileName:  NameBFG = Val(temp)
      Getprivateprofilestring "All", "NameBBG", Str$(%Green), temp, %Max_Path, INIFileName:  NameBBG = Val(temp)
      Getprivateprofilestring "All", "FaceAPos", "1", temp, %Max_Path, INIFileName:  FaceAPos = Val(temp)
      Getprivateprofilestring "All", "FaceBPos", "2", temp, %Max_Path, INIFileName:  FaceBPos = Val(temp)
      Getprivateprofilestring "All", "TeamAPos", "26", temp, %Max_Path, INIFileName:  TeamAPos = Val(temp)
      Getprivateprofilestring "All", "TeamBPos", "27", temp, %Max_Path, INIFileName:  TeamBPos = Val(temp)
      Getprivateprofilestring "All", "MaxTime", "60", temp, %Max_Path, INIFileName:  MaxTime = Val(temp)
      Getprivateprofilestring "All", "ActivePlayer", "1", temp, %Max_Path, INIFileName:  ActivePlayer = Val(temp)
      Getprivateprofilestring "All", "NoSound", "0", temp, %Max_Path, INIFileName: NoSound = Val(temp)
      Getprivateprofilestring "All", "ShowLists", "1", temp, %Max_Path, INIFileName: ShowLists = Val(temp)
      Getprivateprofilestring "All", "AllowDelays", "1", temp, %Max_Path, INIFileName: AllowDelays = Val(temp)
      Getprivateprofilestring "All", "DelayA", "30", temp, %Max_Path, INIFileName: DelayA = Val(temp)
      Getprivateprofilestring "All", "DelayB", "5", temp, %Max_Path, INIFileName: DelayB = Val(temp)
      Getprivateprofilestring "All", "CurrentTimeA", "0", temp, %Max_Path, INIFileName: CurrentTimeA = Val(temp)
      Getprivateprofilestring "All", "CurrentTimeB", "0", temp, %Max_Path, INIFileName: CurrentTimeB = Val(temp)

      Getprivateprofilestring "All", "TotalScoreA", "0", temp, %Max_Path, INIFileName:  TotalScoreA = Val(temp)
      Getprivateprofilestring "All", "TotalScoreB", "0", temp, %Max_Path, INIFileName:  TotalScoreB = Val(temp)
      Getprivateprofilestring "All", "ScoreA", "0", temp, %Max_Path, INIFileName:  ScoreA = Val(temp)
      Getprivateprofilestring "All", "ScoreB", "0", temp, %Max_Path, INIFileName:  ScoreB = Val(temp)
      Getprivateprofilestring "All", "ScoreC", "0", temp, %Max_Path, INIFileName:  ScoreC = Val(temp)
      Getprivateprofilestring "All", "ScoreD", "0", temp, %Max_Path, INIFileName:  ScoreD = Val(temp)
      Getprivateprofilestring "All", "ScoreE", "0", temp, %Max_Path, INIFileName:  ScoreE = Val(temp)
      Getprivateprofilestring "All", "ScoreF", "0", temp, %Max_Path, INIFileName:  ScoreF = Val(temp)
      Getprivateprofilestring "All", "ScoreG", "0", temp, %Max_Path, INIFileName:  ScoreG = Val(temp)
      Getprivateprofilestring "All", "ScoreH", "0", temp, %Max_Path, INIFileName:  ScoreH = Val(temp)
      Getprivateprofilestring "All", "ScoreI", "0", temp, %Max_Path, INIFileName:  ScoreI = Val(temp)
      Getprivateprofilestring "All", "ScoreO", "0", temp, %Max_Path, INIFileName:  ScoreO = Val(temp)
      Getprivateprofilestring "All", "ScoreP", "0", temp, %Max_Path, INIFileName:  ScoreP = Val(temp)
      Getprivateprofilestring "All", "ScoreQ", "0", temp, %Max_Path, INIFileName:  ScoreQ = Val(temp)
      Getprivateprofilestring "All", "ScoreR", "0", temp, %Max_Path, INIFileName:  ScoreR = Val(temp)
      Getprivateprofilestring "All", "ScoreS", "0", temp, %Max_Path, INIFileName:  ScoreS = Val(temp)
      Getprivateprofilestring "All", "ScoreT", "0", temp, %Max_Path, INIFileName:  ScoreT = Val(temp)
      Getprivateprofilestring "All", "ScoreU", "0", temp, %Max_Path, INIFileName:  ScoreU = Val(temp)
      Getprivateprofilestring "All", "ScoreV", "0", temp, %Max_Path, INIFileName:  ScoreV = Val(temp)
      Getprivateprofilestring "All", "ScoreW", "0", temp, %Max_Path, INIFileName:  ScoreW = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x

   ElseIf Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      WritePrivateProfileString "All", "NameA", NameAText, INIFileName
      WritePrivateProfileString "All", "NameB", NameBText, INIFileName
      WritePrivateProfileString "All", "SportName", SportName, INIFileName
      WritePrivateProfileString "All", "GameStatus", GameStatus, INIFileName

      For x = 0 To 9
         WritePrivateProfileString "History", "History" + Format$(x,"0"), History(x), INIFileName
      Next x

      'save numeric variables
      WritePrivateProfileString "All", "NameAFG", (Str$(NameAFG)), INIFileName
      WritePrivateProfileString "All", "NameABG", (Str$(NameABG)), INIFileName
      WritePrivateProfileString "All", "NameBFG", (Str$(NameBFG)), INIFileName
      WritePrivateProfileString "All", "NameBBG", (Str$(NameBBG)), INIFileName
      WritePrivateProfileString "All", "FaceAPos", (Str$(FaceAPos)), INIFileName
      WritePrivateProfileString "All", "FaceBPos", (Str$(FaceBPos)), INIFileName
      WritePrivateProfileString "All", "TeamAPos", (Str$(TeamAPos)), INIFileName
      WritePrivateProfileString "All", "TeamBPos", (Str$(TeamBPos)), INIFileName
      WritePrivateProfileString "All", "MaxTime", (Str$(MaxTime)), INIFileName
      WritePrivateProfileString "All", "ActivePlayer", (Str$(ActivePlayer)), INIFileName
      WritePrivateProfileString "All", "NoSound", (Str$(NoSound)), INIFileName
      WritePrivateProfileString "All", "ShowLists", (Str$(ShowLists)), INIFileName
      WritePrivateProfileString "All", "AllowDelays", (Str$(AllowDelays)), INIFileName
      WritePrivateProfileString "All", "DelayA", (Str$(DelayA)), INIFileName
      WritePrivateProfileString "All", "DelayB", (Str$(DelayB)), INIFileName
      WritePrivateProfileString "All", "CurrentTimeA", (Str$(CurrentTimeA)), INIFileName
      WritePrivateProfileString "All", "CurrentTimeB", (Str$(CurrentTimeB)), INIFileName

      WritePrivateProfileString "All", "TotalScoreA", (Str$(TotalScoreA)), INIFileName
      WritePrivateProfileString "All", "TotalScoreB", (Str$(TotalScoreB)), INIFileName

      WritePrivateProfileString "All", "ScoreA", (Str$(ScoreA)), INIFileName
      WritePrivateProfileString "All", "ScoreB", (Str$(ScoreB)), INIFileName
      WritePrivateProfileString "All", "ScoreC", (Str$(ScoreC)), INIFileName
      WritePrivateProfileString "All", "ScoreD", (Str$(ScoreD)), INIFileName
      WritePrivateProfileString "All", "ScoreE", (Str$(ScoreE)), INIFileName
      WritePrivateProfileString "All", "ScoreF", (Str$(ScoreF)), INIFileName
      WritePrivateProfileString "All", "ScoreG", (Str$(ScoreG)), INIFileName
      WritePrivateProfileString "All", "ScoreH", (Str$(ScoreH)), INIFileName
      WritePrivateProfileString "All", "ScoreI", (Str$(ScoreI)), INIFileName

      WritePrivateProfileString "All", "ScoreO", (Str$(ScoreO)), INIFileName
      WritePrivateProfileString "All", "ScoreP", (Str$(ScoreP)), INIFileName
      WritePrivateProfileString "All", "ScoreQ", (Str$(ScoreQ)), INIFileName
      WritePrivateProfileString "All", "ScoreR", (Str$(ScoreR)), INIFileName
      WritePrivateProfileString "All", "ScoreS", (Str$(ScoreS)), INIFileName
      WritePrivateProfileString "All", "ScoreT", (Str$(ScoreT)), INIFileName
      WritePrivateProfileString "All", "ScoreU", (Str$(ScoreU)), INIFileName
      WritePrivateProfileString "All", "ScoreV", (Str$(ScoreV)), INIFileName
      WritePrivateProfileString "All", "ScoreW", (Str$(ScoreW)), INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(x,"00"), temp, INIFileName
      Next

   End If
End Function

Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(16)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1    : ac(cc).cmd  = %IDT_Help     : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F4    : ac(cc).cmd  = %IDM_SelectSport     : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F5    : ac(cc).cmd  = %IDM_ClearHistory    : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F6    : ac(cc).cmd  = %IDM_SetDelayValues  : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F7    : ac(cc).cmd  = %IDM_NoSound         : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F8    : ac(cc).cmd  = %IDM_ScoreSound      : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F9    : ac(cc).cmd  = %IDM_AllowDelays     : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F10    : ac(cc).cmd  = %IDM_GameStatus     : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_Escape: ac(cc).cmd  = %IDM_Escape   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N     : ac(cc).cmd  = %IDT_New      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_R     : ac(cc).cmd  = %IDT_Switch   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_M     : ac(cc).cmd  = %IDT_Anthem   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_1     : ac(cc).cmd  = %IDT_Time1    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_3     : ac(cc).cmd  = %IDT_Time3    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_5     : ac(cc).cmd  = %IDT_Time5    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S     : ac(cc).cmd  = %IDT_Start    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_T     : ac(cc).cmd  = %IDM_Test     : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub LoadSounds
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub BuildFonts
   Local i As Long
   Font New "Comic Sans MS", 48, 1, 0 To hFont
   Font New "Comic Sans MS", 18, 1, 0 To hFontB
   Font New "Comic Sans MS", 24, 1, 0 To hFontS
   Font New "Comic Sans MS", 48, 1, 0 To hFontM   'used in DrawGame only

   Control Set Font hDlg, %IDC_TotalScoreA, hFontS
   Control Set Font hDlg, %IDC_TotalScoreB, hFontS
   Control Set Font hDlg, %IDC_Toolbar, hFontB

   For i = %IDC_FrameA To %IDC_NameBText
      Control Set Font hDlg, i, hFontB
   Next i
End Sub

Sub LoadImageToMemoryBitmap (ImgName As String, hWin As Dword, w As Long, h As Long, hDC As Dword)
   GdipLoadImageFromFile((ImgName), pImage)           'load image
   GdipGetImageWidth(pImage,w)                        'get width
   GdipGetImageHeight(pImage, h)                      'get height

   Graphic Bitmap New w,h To hWin
   Graphic Attach hWin, 0
   Graphic Get DC To hDC

   GdipCreateFromHDC(hDC, pGraphics)                  ' Create the Graphic object
   GdipDrawImage(pGraphics, pImage, 0, 0)             ' Draw the image
End Sub

Sub LoadFaceImages
   Local temp$, iCount,i,x,y As Long
   Local hFaceListDC As Dword, imgName As String
   Local wCont, hCont, wNew, hNew, wImg, hImg As Long
   Local preGraphics As Dword

   'put Face filenames into array
   iCount = -1
   temp$ = Dir$("faces\*.*")
   While Len(temp$)
      Incr iCount
      ReDim Preserve Faces(iCount)
      Faces(iCount) = Exe.Path$ + "faces\" + temp$
      temp$ = Dir$(Next)
   Wend
   Graphic Attach hDlg, %IDC_FaceList
   Graphic Clear
   Graphic Get DC To hFaceListDC
   Graphic Set Virtual (iCount+1)*80, 64

   wCont = 80 : hCont = 64
   For i = 0 To UBound(Faces)
         'display image
         imgName = Faces(i)
         GdipLoadImageFromFile((imgName), pImage)        'load image
         GdipCreateFromHDC(hFaceListDC, preGraphics)     ' Create the Graphic object
         GdipGetImageWidth(pImage,wImg)
         GdipGetImageHeight(pImage, hImg)

         'wCont,hCont = container size : hImg,wImg = original image size : wNew,hNew = image size to fit in container
         wNew = wImg / Max(wImg / wCont, hImg / hCont)
         hNew = hImg / Max(wImg / wCont, hImg / hCont)

         x = i * wCont + (wCont-wNew)/2
         y = (hCont - hNew) / 2

         GdipDrawImageRect(preGraphics, pImage,x,y,wNew,hNew)  'draw image
         'cleanup
         If pImage Then GdipDisposeImage(pImage)
         If preGraphics Then GdipDeleteGraphics(preGraphics)
   Next i

End Sub

Sub LoadTeamImages
   Local temp$, iCount,i,x,y As Long
   Local hTeamListDC As Dword, imgName As String
   Local wCont, hCont, wNew, hNew, wImg, hImg As Long
   Local preGraphics  As Dword

   ReDim Teams(0)

   'put Team filenames into array
   iCount = -1
   temp$ = Dir$("sport\" + SportName + "\*.*")
   While Len(temp$)
      Incr iCount
      ReDim Preserve Teams(iCount)
      Teams(iCount) = Exe.Path$ + "sport\" + SportName + "\" +  temp$
      temp$ = Dir$(Next)
   Wend
   Graphic Attach hDlg, %IDC_TeamList, ReDraw
   Graphic Clear
   Graphic Get DC To hTeamListDC
   Graphic Set Virtual (iCount+1)*IIf(SportName = "Hockey" Or SportName = "Football",100,80), 64

   wCont = 80 : hCont = 64
   For i = 0 To UBound(Teams)
         'display image
         imgName = Teams(i)
         GdipLoadImageFromFile((imgName), pImage)        'load image
         GdipCreateFromHDC(hTeamListDC, preGraphics)     ' Create the Graphic object
         GdipGetImageWidth(pImage,wImg)
         GdipGetImageHeight(pImage, hImg)

         'wCont,hCont = container size : hImg,wImg = original image size : wNew,hNew = image size to fit in container
         wNew = wImg / Max(wImg / wCont, hImg / hCont)
         hNew = hImg / Max(wImg / wCont, hImg / hCont)

         x = i * (wCont + IIf(SportName = "Hockey" Or SportName = "Football",20,0)) + (wCont-wNew)/2
         y = (hCont - hNew) / 2

         GdipDrawImageRect(preGraphics, pImage,x,y,wNew,hNew)  'draw image
         'cleanup
         If pImage Then GdipDisposeImage(pImage)
         If preGraphics Then GdipDeleteGraphics(preGraphics)
   Next i
   Graphic ReDraw
End Sub

Sub LoadSingleFaceImage(iPos As Long, hFaceDC As Dword)
   Local x,y As Long
   Local imgName As String
   Local wCont, hCont, wNew, hNew, wImg, hImg As Long
   Local preGraphics As Dword

   wCont = 64 : hCont = 64
   'display image
   imgName = Faces(iPos)
   GdipLoadImageFromFile((imgName), pImage)        'load image
   GdipCreateFromHDC(hFaceDC, preGraphics)     ' Create the Graphic object
   GdipGetImageWidth(pImage,wImg)
   GdipGetImageHeight(pImage, hImg)

   'wCont,hCont = container size : hImg,wImg = original image size : wNew,hNew = image size to fit in container
   wNew = wImg / Max(wImg / wCont, hImg / hCont)
   hNew = hImg / Max(wImg / wCont, hImg / hCont)

   x = (wCont-wNew)/2
   y = (hCont - hNew) / 2

   GdipDrawImageRect(preGraphics, pImage,x,y,wNew,hNew)  'draw image
   'cleanup
   If pImage Then GdipDisposeImage(pImage)
   If preGraphics Then GdipDeleteGraphics(preGraphics)
End Sub

Sub LoadSingleTeamImage(iPos As Long, hTeamDC As Dword)
   Local x,y As Long
   Local imgName As String
   Local wCont, hCont, wNew, hNew, wImg, hImg As Long
   Local preGraphics As Dword

   wCont = 64 : hCont = 64
   'display image
   imgName = Teams(iPos)

   GdipLoadImageFromFile((imgName), pImage)        'load image
   GdipCreateFromHDC(hTeamDC, preGraphics)     ' Create the Graphic object
   GdipGetImageWidth(pImage,wImg)
   GdipGetImageHeight(pImage, hImg)

   'wCont,hCont = container size : hImg,wImg = original image size : wNew,hNew = image size to fit in container
   wNew = wImg / Max(wImg / wCont, hImg / hCont)
   hNew = hImg / Max(wImg / wCont, hImg / hCont)

   x = (wCont-wNew)/2
   y = (hCont - hNew) / 2

   GdipDrawImageRect(preGraphics, pImage,x,y,wNew,hNew)  'draw image
   'cleanup
   If pImage Then GdipDisposeImage(pImage)
   If preGraphics Then GdipDeleteGraphics(preGraphics)
End Sub

Sub ReadText (sText As String)
   If NoSound And Left$(sText,1) <> "z" Then Exit Sub
   Local vRes, vTxt, vTime As Variant, oSp As Dispatch
   Let oSp = NewCom "SAPI.SpVoice"
   If IsFalse IsObject(oSp) Then Exit Sub
   vTxt = sText
   Object Call oSp.Speak(vTxt) To vRes
   vTime = -1 As Long
   Object Call oSp.WaitUntilDone(vTime) To vRes
End Sub

Sub CreateToolbar
    ImageList New Icon 96,96,24,50 To hImageList
    ImageList Add Icon hImageList, "xstart"   '1
    ImageList Add Icon hImageList, "xnew"     '2
    ImageList Add Icon hImageList, "xhelp"    '3
    ImageList Add Icon hImageList, "x1"       '4
    ImageList Add Icon hImageList, "x3"       '5
    ImageList Add Icon hImageList, "x5"       '6
    ImageList Add Icon hImageList, "xswitch"  '7
    ImageList Add Icon hImageList, "xsong"    '8
    ImageList Add Icon hImageList, "x1b"      '9
    ImageList Add Icon hImageList, "x3b"      '10
    ImageList Add Icon hImageList, "x5b"      '11
    ImageList Add Icon hImageList, "xlists"   '12
    ImageList Add Icon hImageList, "xstartb"  '13
    ImageList Add Icon hImageList, "xlistsb"  '14

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_New, %BTNS_Button, ""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_Start, %BTNS_Check, ""
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Time1,  %BTNS_CheckGroup, ""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Time3,  %BTNS_CheckGroup, ""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Time5,  %BTNS_CheckGroup, ""
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Switch,  %BTNS_Button, ""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Anthem,  %BTNS_Button, ""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12,  %IDT_ShowLists, %BTNS_Check, ""
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Help,  %BTNS_Button, ""
End Sub

Sub ResetToolbarImages
   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_Start
   Toolbar Add Button hDlg, %IDC_Toolbar, IIf(GameStatus="Off" Or GameStatus="Pause",1,13), %IDT_Start, %BTNS_Check, "" At 2

   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_ShowLists
   Toolbar Add Button hDlg, %IDC_Toolbar, IIf(ShowLists,14,12), %IDT_ShowLists, %BTNS_Check, "" At 10

   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_Time1
   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_Time3
   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_Time5
   Toolbar Add Button hDlg, %IDC_Toolbar, IIf(MaxTime=300,11,6), %IDT_Time5, %BTNS_CheckGroup, "" At 4
   Toolbar Add Button hDlg, %IDC_Toolbar, IIf(MaxTime=180,10,5), %IDT_Time3, %BTNS_CheckGroup, "" At 4
   Toolbar Add Button hDlg, %IDC_Toolbar, IIf(MaxTime=60,9,4), %IDT_Time1, %BTNS_CheckGroup, "" At 4
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Start, IIf(GameStatus="Off" Or GameStatus="Pause",0,%TBState_Checked) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowLists, IIf(ShowLists,%TBState_Checked,0) Or %TBState_Enabled

    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Time1, IIf(MaxTime=60,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Time3, IIf(MaxTime=180,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Time5, IIf(MaxTime=300,%TBState_Checked,0) Or %TBState_Enabled

   'Menus
'    Menu Set State hSettings, ByCmd %IDM_AskConfirmation, AskConfirmation * %MFS_Checked Or %MFS_Enabled

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_New        : Function = "New Game"
      Case %IDT_Start      : Function = "Start/Stop Game"
      Case %IDT_Time1      : Function = "1 Minute Player Time"
      Case %IDT_Time3      : Function = "3 Minute Player Time"
      Case %IDT_Time5      : Function = "5 Minute Player Time"
      Case %IDT_Switch     : Function = "Reverse Player Sides"
      Case %IDT_Anthem     : Function = "Play/Stop Song"
      Case %IDT_ShowLists  : Function = "Show Face/Team Image Lists"
      Case %IDT_Help       : Function = "Online Help"
   End Select
End Function

Sub BuildScore
   Local temp$
   TotalScoreA = 0
   TotalScoreB = 0

   Control Get Text hDlg, %IDC_ScoreA To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreB To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreC To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreD To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreE To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreF To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreG To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreH To temp$ : TotalScoreA += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreI To temp$ : TotalScoreA += Val(temp$)

   Control Get Text hDlg, %IDC_ScoreO To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreP To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreQ To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreR To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreS To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreT To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreU To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreV To temp$ : TotalScoreB += Val(temp$)
   Control Get Text hDlg, %IDC_ScoreW To temp$ : TotalScoreB += Val(temp$)

   Control Set Text hDlg, %IDC_TotalScoreA, LTrim$(Str$(TotalScoreA))
   Control Set Text hDlg, %IDC_TotalScoreB, LTrim$(Str$(TotalScoreB))
End Sub

Sub SwitchSides
   Swap NameAText, NameBText
   Swap FaceAPos, FaceBPos
   Swap TeamAPos, TeamBPos
   Swap CurrentTimeA, CurrentTimeB
   Swap TotalScoreA, TotalScoreB
   Swap NameAFG, NameBFG
   Swap NameABG, NameBBG
   Swap ScoreA, ScoreO
   Swap ScoreB, ScoreP
   Swap ScoreC, ScoreQ
   Swap ScoreD, ScoreR
   Swap ScoreE, ScoreS
   Swap ScoreF, ScoreT
   Swap ScoreG, ScoreU
   Swap ScoreH, ScoreV
   Swap ScoreI, ScoreW
End Sub

Sub ClearValues
   ActivePlayer = 1 : ColorActivePlayer
   GameStatus = "Off"
   TeamAPos = 0
   TeamBPos = 1
   PeriodCount = 0
   CurrentTimeA = 0
   CurrentTimeB = 0
   TotalScoreA = 0
   TotalScoreB = 0
   DelayCount = 0

   ScoreA = 0
   ScoreB = 0
   ScoreC = 0
   ScoreD = 0
   ScoreE = 0
   ScoreF = 0
   ScoreG = 0
   ScoreH = 0
   ScoreI = 0

   ScoreO = 0
   ScoreP = 0
   ScoreQ = 0
   ScoreR = 0
   ScoreS = 0
   ScoreT = 0
   ScoreU = 0
   ScoreV = 0
   ScoreW = 0
End Sub

Sub RestoreControlValues
   Local temp$
   temp = NameBText
   Control Set Text hDlg, %IDC_NameAText, NameAText
   Control Set Text hDlg, %IDC_NameBText, temp$

   Graphic Attach hDlg, %IDC_FaceA : Graphic Clear : LoadSingleFaceImage FaceAPos, hFaceADC
   Graphic Attach hDlg, %IDC_FaceB : Graphic Clear : LoadSingleFaceImage FaceBPos, hFaceBDC
   Graphic Attach hDlg, %IDC_TeamA : Graphic Clear : LoadSingleTeamImage TeamAPos, hTeamADC
   Graphic Attach hDlg, %IDC_TeamB : Graphic Clear : LoadSingleTeamImage TeamBPos, hTeamBDC

   Control Set Text hDlg, %IDC_TotalScoreA, LTrim$(Str$(TotalScoreA))
   Control Set Text hDlg, %IDC_TotalScoreB, LTrim$(Str$(TotalScoreB))

   Control Set Color hDlg, %IDC_TotalScoreA, NameAFG, NameABG
   Control Set Color hDlg, %IDC_TotalScoreB, NameBFG, NameBBG
   Control Set Color hDlg, %IDC_NameAFG, %Black, NameAFG
   Control Set Color hDlg, %IDC_NameABG, %Black, NameABG
   Control Set Color hDlg, %IDC_NameBFG, %Black, NameBFG
   Control Set Color hDlg, %IDC_NameBBG, %Black, NameBBG
   Control Set Text hDlg, %IDC_ScoreA, LTrim$(Str$(ScoreA))
   Control Set Text hDlg, %IDC_ScoreB, LTrim$(Str$(ScoreB))
   Control Set Text hDlg, %IDC_ScoreC, LTrim$(Str$(ScoreC))
   Control Set Text hDlg, %IDC_ScoreD, LTrim$(Str$(ScoreD))
   Control Set Text hDlg, %IDC_ScoreE, LTrim$(Str$(ScoreE))
   Control Set Text hDlg, %IDC_ScoreF, LTrim$(Str$(ScoreF))
   Control Set Text hDlg, %IDC_ScoreG, LTrim$(Str$(ScoreG))
   Control Set Text hDlg, %IDC_ScoreH, LTrim$(Str$(ScoreH))
   Control Set Text hDlg, %IDC_ScoreI, LTrim$(Str$(ScoreI))

   Control Set Text hDlg, %IDC_ScoreO, LTrim$(Str$(ScoreO))
   Control Set Text hDlg, %IDC_ScoreP, LTrim$(Str$(ScoreP))
   Control Set Text hDlg, %IDC_ScoreQ, LTrim$(Str$(ScoreQ))
   Control Set Text hDlg, %IDC_ScoreR, LTrim$(Str$(ScoreR))
   Control Set Text hDlg, %IDC_ScoreS, LTrim$(Str$(ScoreS))
   Control Set Text hDlg, %IDC_ScoreT, LTrim$(Str$(ScoreT))
   Control Set Text hDlg, %IDC_ScoreU, LTrim$(Str$(ScoreU))
   Control Set Text hDlg, %IDC_ScoreV, LTrim$(Str$(ScoreV))
   Control Set Text hDlg, %IDC_ScoreW, LTrim$(Str$(ScoreW))

   Control Set Text hDlg, %IDC_NameAText, NameAText
   Control Set Text hDlg, %IDC_NameBText, NameBText

   Control Set Color hDlg, %IDC_NameAFG, %Black, NameAFG
   Control Set Color hDlg, %IDC_NameABG, %Black, NameABG
   Control Set Color hDlg, %IDC_NameBBG, %Black, NameBBG
   Control Set Color hDlg, %IDC_NameBFG, %Black, NameBFG

   DrawGameBackGround

   Control Disable hdlg, %IDC_FrameA
   Control Disable hdlg, %IDC_FrameB
   Dialog ReDraw hDlg
   Control Enable hdlg, %IDC_FrameA
   Control Enable hdlg, %IDC_FrameB
End Sub

Sub GetScores
   Local temp$
   Control Get Text hDlg, %IDC_ScoreA To temp$ : ScoreA = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreB To temp$ : ScoreB = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreC To temp$ : ScoreC = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreD To temp$ : ScoreD = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreE To temp$ : ScoreE = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreF To temp$ : ScoreF = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreG To temp$ : ScoreG = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreH To temp$ : ScoreH = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreI To temp$ : ScoreI = Val(temp$)

   Control Get Text hDlg, %IDC_ScoreO To temp$ : ScoreO = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreP To temp$ : ScoreP = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreQ To temp$ : ScoreQ = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreR To temp$ : ScoreR = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreS To temp$ : ScoreS = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreT To temp$ : ScoreT = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreU To temp$ : ScoreU = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreV To temp$ : ScoreV = Val(temp$)
   Control Get Text hDlg, %IDC_ScoreW To temp$ : ScoreW = Val(temp$)
End Sub

Sub TimeDelayA
   DelayCount = DelayA
   DisplayWaitDialog(hDlg)
End Sub

Sub TimeDelayB
   DelayCount = DelayB * 60
   DisplayWaitDialog(hDlg)
End Sub

Sub DrawGameBackGround
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Color -1,-1
   Graphic Clear

   'BackGround
   Graphic Set Font hFont
   Graphic Width 5

   'get player names
   Control Get Text hDlg, %IDC_NameAText To NameAText
   Control Get Text hDlg, %IDC_NameBText To NameBText

   If ActivePlayer = 1 Then
      'box
      Graphic Box (10,20)-(900,170), , NameAFG, NameABG
      'name of active player
      Graphic Color NameAFG, -2
      Graphic Set Pos (40,40)
      Graphic Print NameAText
      'path of moving ball
      Graphic Line (300,90)-(675,90), NameAFG
      Graphic Line (300,60)-(300,120),NameAFG
      Graphic Line (675,60)-(675,120),NameAFG
   Else
      'box
      Graphic Box (10,20)-(900,170), , NameBFG, NameBBG
      'name of active player
      Graphic Color NameBFG, -2
      Graphic Set Pos (40,40)
      Graphic Print NameBText
      'path of moving ball
      Graphic Line (300,90)-(675,90), NameBFG
      Graphic Line (300,60)-(300,120),NameBFG
      Graphic Line (675,60)-(675,120),NameBFG
   End If

   If GameStatus <> "On" Then
      'big baseball images
      TransparentBlt hGraphicDC,300-64,95-64,128,128,hImageDC,0,0,128,128,%Black
      'set time to zero
      If DelayCount = 0 Then
         Graphic Set Pos (725,40)
         Graphic Print Format$(MaxTime\60,"0") + ":" + Format$(MaxTime Mod 60,"00")
      End If
   End If

   Control Set Text hDlg, %IDC_PeriodA, RTrim$(PeriodName) + ": 1"
   Control Set Text hDlg, %IDC_PeriodB, RTrim$(PeriodName) + ": 1"

   HidePeriod

   Graphic ReDraw
   Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, StatusBarContent
End Sub

Sub DrawGame
   Local x,y As Long
   Graphic Attach hDlg, %IDC_Graphic, ReDraw

   Graphic Set Font hFontM

   HighlightPeriod

   If ActivePlayer = 1 Then
      If CurrentTimeA = 0 And GameStatus = "On" Then
         'display moving ball at starting position
         x = 300 : y = 95
         TransparentBlt hGraphicDC,x-64,y-64,128,128,hImageDC,0,0,128,128,%Black

         'set time to zero
         Graphic Color NameAFG, -2
         Graphic Set Pos (725,40)
         Graphic Print Format$(MaxTime\60,"0") + ":" + Format$(MaxTime Mod 60,"00")
         Graphic ReDraw

         'say whose turn it is
         KillTimer hDlg, %ID_Timer
         ReadText "It is " + NameAText + "s turn"

         'transition time
         If AllowDelays Then
            ReadText "There will be a " + Str$(DelayA) + " second delay while " + NameAText + " gets ready to play"
            GameStatus = "WaitingForA"
            TimeDelayA
         Else
            GameStatus = "On"
            SetTimer hDlg, %ID_Timer, 1000, ByVal(%Null)
         End If
         Incr CurrentTimeA

      ElseIf CurrentTimeA = MaxTime Then
         'display moving ball at ending position
         x = 675 : y = 95
         TransparentBlt hGraphicDC,x-64,y-64,128,128,hImageDC,0,0,128,128,%Black

         'set time to MaxTime
         Graphic Color NameAFG, -2
         Graphic Set Pos (725,40)
         Graphic Print "0:00"
         Graphic ReDraw

         'say time is up
         ReadText NameAText + "s turn is over"

         CurrentTimeA = 0 : CurrentTimeB = 0 : ActivePlayer = 2 : ColorActivePlayer
         Exit Sub

      Else
         'display moving ball at interim position
         x = 300 + 375 * CurrentTimeA / MaxTime :  y = 95
         TransparentBlt hGraphicDC,x-64,y-64,128,128,hImageDC,0,0,128,128,%Black

         'display the time
         Graphic Color NameAFG, -2
         Graphic Set Pos (725,40)
         Graphic Print Format$(Abs(MaxTime-CurrentTimeA)\60,"0")+ ":" + Format$(Abs(MaxTime-CurrentTimeA) Mod 60,"00")

         If CurrentTimeA Mod 60 = 0 Then
            Graphic ReDraw
            ReadText "Time remaining is " + Str$((MaxTime-CurrentTimeA)\ 60) + " minutes"
         End If
         Incr CurrentTimeA
      End If

   End If

   If ActivePlayer = 2 Then
      If CurrentTimeB = 0 And GameStatus = "On" Then
         'display moving ball at starting position
         x = 300 : y = 95
         TransparentBlt hGraphicDC,x-64,y-64,128,128,hImageDC,0,0,128,128,%Black

         'set time to zero
         Graphic Color NameBFG, -2
         Graphic Set Pos (725,40)
         Graphic Print Format$(MaxTime\60,"0") + ":" + Format$(MaxTime Mod 60,"00")
         Graphic ReDraw

         'say whose turn it is
         KillTimer hDlg, %ID_Timer
         ReadText "It is " + NameBText + "s turn to play"

         'transition time
         If AllowDelays Then
            ReadText "There will be a " + Str$(DelayA) + " second delay while " + NameBText + " comes to play"
            GameStatus = "WaitingForB"
            TimeDelayA
         Else
            GameStatus = "On"
            SetTimer hDlg, %ID_Timer, 1000, ByVal(%Null)
         End If
         Incr CurrentTimeB

      ElseIf CurrentTimeB = MaxTime Then
         'display moving ball at ending position
         x = 675 : y = 95
         TransparentBlt hGraphicDC,x-64,y-64,128,128,hImageDC,0,0,128,128,%Black

         'set time to MaxTime
         Graphic Color NameBFG, -2
         Graphic Set Pos (725,40)
         Graphic Print "0:00"
         Graphic ReDraw

         'say time is up
         Incr PeriodCount
         Control Set Text hDlg, %IDC_PeriodA, RTrim$(PeriodName) + ":" + Str$(PeriodCount)
         Control Set Text hDlg, %IDC_PeriodB, RTrim$(PeriodName) + ":" + Str$(PeriodCount)

         KillTimer hDlg, %ID_Timer
         ReadText NameBText + "s turn is over"

         If PeriodCount = Periods Then
            'end of game
            PeriodCount = 0
            KillTimer hDlg, %ID_Timer
            Play Wave "sounds\alarm.wav", Synch
            GameStatus = "Off"
            ResetToolbarImages
            SetMenusAndToolbar
            ReadText "The game is over"
         Else
            'more innings
            ReadText "The" + PeriodName + "is over"
            If AllowDelays Then
               ReadText "There will be a " + Str$(DelayB) + " minute delay before the next" + PeriodName + "starts"
               GameStatus = "WaitingForInning"
               TimeDelayB
            End If
         End If

         CurrentTimeA = 0 : CurrentTimeB = 0 : ActivePlayer = 1 : ColorActivePlayer
      Else
         'display moving ball at interim position
         x = 300 + 375 * CurrentTimeB / MaxTime :  y = 95
         TransparentBlt hGraphicDC,x-64,y-64,128,128,hImageDC,0,0,128,128,%Black

         'display the time
         Graphic Color NameBFG, -2
         Graphic Set Pos (725,40)
         Graphic Print Format$(Abs(MaxTime-CurrentTimeB)\60,"0")+ ":" + Format$(Abs(MaxTime-CurrentTimeB) Mod 60,"00")

         If CurrentTimeB Mod 60 = 0 Then
            Graphic ReDraw
            ReadText "Time remaining is " + Str$((MaxTime-CurrentTimeB)\ 60) + " minutes"
         End If
         Incr CurrentTimeB
      End If
   End If
   Graphic ReDraw
End Sub

Function StatusBarContent() As String
   Local temp$
   temp$ = "  Player: " + IIf$(ActivePlayer=1,NameAText,NameBText)
   temp+=  "   ...   " + MCase$(PathName$(Name,Teams(IIf(ActivePlayer=1,TeamAPos,TeamBPos))))
   Function = temp$
End Function

Sub ColorActivePlayer
   If ActivePlayer = 1 Then
      Control Set Color hDlg, %IDC_FrameA, NameAFG, NameABG
      Control Set Color hDlg, %IDC_FrameB, %Black, -1
   ElseIf ActivePlayer = 2 Then
      Control Set Color hDlg, %IDC_FrameA, %Black, -1
      Control Set Color hDlg, %IDC_FrameB, NameBFG, NameBBG
   End If
   Control ReDraw hDlg, %IDC_FrameA
   Control ReDraw hDlg, %IDC_FrameB
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, StatusbarContent
End Sub

Sub SetPeriods
   If SportName = "Baseball"   Then Periods = 9  'innings
   If SportName = "Basketball" Then Periods = 4  'periods
   If SportName = "Football"   Then Periods = 4  'quarters
   If SportName = "Hockey"     Then Periods = 3  'periods
   If SportName = "Soccer"     Then Periods = 2  'halves
End Sub

Sub CreateScoreBoxes
   Local i As Long
   'Player1
   For i = 0 To Periods-1
      If Periods > 6 Then
         'baseball
         Control Add TextBox, hDlg, %IDC_ScoreA+i, "0", 40+(i*48),250,40,40, %WS_TabStop Or %WS_Border Or %ES_Center Or %ES_AutoHScroll
      Else
         Control Add TextBox, hDlg, %IDC_ScoreA+i, "0", 45+(i*65),250,55,40, %WS_TabStop Or %WS_Border Or %ES_Center Or %ES_AutoHScroll
      End If
      Control Add "msctls_updown32", hDlg, %IDC_ScoreAA+i, "", 0, 0, 8, 8, %WS_Child Or %WS_Border _
         Or %WS_Visible Or %UDS_ArrowKeys Or %UDS_AlignRight Or %UDS_SetBuddyInt
      Control Send hDlg, %IDC_ScoreAA+i, %UDM_SetBuddy, GetDlgItem(hDlg, %IDC_ScoreA+i), 0
      Control Send hDlg, %IDC_ScoreAA+i, %UDM_SetRange, 0, Mak(Long,100,0)   'Max,Min
   Next i
   'Player2
   For i = 0 To Periods-1
      If Periods = 9 Then
         'baseball
         Control Add TextBox, hDlg, %IDC_ScoreO+i, "0", 525+(i*48),250,40,40, %WS_TabStop Or %WS_Border Or %ES_Center Or %ES_AutoHScroll
      Else
         Control Add TextBox, hDlg, %IDC_ScoreO+i, "0", 525+(i*65),250,55,40, %WS_TabStop Or %WS_Border Or %ES_Center Or %ES_AutoHScroll
      End If
      Control Add "msctls_updown32", hDlg, %IDC_ScoreOO+i, "", 0, 0, 8, 8, %WS_Child Or %WS_Border _
         Or %WS_Visible Or %UDS_ArrowKeys Or %UDS_AlignRight Or %UDS_SetBuddyInt
      Control Send hDlg, %IDC_ScoreOO+i, %UDM_SetBuddy, GetDlgItem(hDlg, %IDC_ScoreO+i), 0
      Control Send hDlg, %IDC_ScoreOO+i, %UDM_SetRange, 0, Mak(Long,100,0)   'Max,Min
   Next i

   For i = %IDC_ScoreA To %IDC_ScoreW
      Control Set Font hDlg, i, hFontB
   Next i

End Sub

Sub KillScoreBoxes
   Local i As Long
   For i = 0 To Periods-1
      Control Kill hDlg, %IDC_ScoreA+i
      Control Kill hDlg, %IDC_ScoreAA+i
      Control Kill hDlg, %IDC_ScoreO+i
      Control Kill hDlg, %IDC_ScoreOO+i
   Next i
End Sub

Sub DisplaySport
   Local w,h As Long
   'new game
   ClearValues
   'load the sport images and show correct number of periods
   KillScoreBoxes
   SetPeriods
   CreateScoreBoxes
   LoadTeamImages
   LoadImageToMemoryBitmap Exe.Path$ + "images\" + SportName + ".png", hImage, w,h, hImageDC
   RestoreControlValues
   DrawGameBackGround
   Select Case SportName
      Case "Basketball" : ReadText "You selected basketball, which has 4 periods"
      Case "Football"   : ReadText "You selected football, which has 4 quarters"
      Case "Hockey"     : ReadText "You selected hockey, which has three periods"
      Case "Soccer"     : ReadText "You selected soccer, which has two halves"
      Case "Baseball"   : ReadText "You selected baseball, which has nine innings"
   End Select
End Sub

Sub DisplayWaitDialog(hParent As Dword)
   Local x As Long, y As Long, w As Long, h As Long, wX As Long, wY As Long
   Dialog Get Client hParent To w,h
   wX = w-100 : wY = 380
   x = (w-wX)/2    'gets left position of WaitDialog to center over app
   y = (h-wY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", x, y, wX, wY, %WS_Popup To hWait
   Control Add Label, hWait, %IDW_Label, "", 0, 0, wX, wY , %SS_Center Or %SS_Notify 'Or %SS_CenterImage Or %WS_Border
   Control Set Color hWait, %IDW_Label, %Yellow, %rgb_DarkRed
   Control Set Font hWait, %IDW_Label, hFont
   Dialog Show Modal hWait Call hWDlgProc
End Sub

CallBack Function hWDlgProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         PrintDelayMessage
         SetTimer hDlg, %ID_TimerDelay, 1000, ByVal(%Null)
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel  : Dialog End hWait
            Case %IDW_Label : Dialog End hWait
         End Select
      Case %WM_Destroy
         KillTimer hDlg, %ID_TimerDelay
         Select Case GameStatus
            Case "WaitingForA"
               ReadText NameAText + "s turn has now started"
            Case "WaitingForB"
               ReadText NameBText + "s turn has now started"
            Case "WaitingForInning"
               ReadText "The next" + PeriodName +  "will now start"
         End Select
         GameStatus = "On"
         SetTimer hDlg, %ID_Timer, 1000, ByVal(%Null)
   End Select
End Function

Sub PlayScoreSound
   Select Case SportName
      Case "Baseball"   : ReadText "The runner scores"
      Case "Basketball" : ReadText "The shooter makes a basket"
      Case "Football"   : ReadText "The team scores a touchdown"
      Case "Hockey"     : ReadText "The shot scores. Goal"
      Case "Soccer"     : ReadText "The kick is good. Goal"
   End Select
End Sub

Function PeriodName() As String
   Select Case SportName
      Case "Basketball" : Function = " Period "
      Case "Football"   : Function = " Quarter "
      Case "Hockey"     : Function = " Period "
      Case "Soccer"     : Function = " Half "
      Case "Baseball"   : Function = " Inning "
   End Select
End Function

Sub DisplayListControls
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   If ShowLists Then
      Dialog Set Client hDlg, w, 830
      Control Set Loc hDlg, %IDC_BorderB,160,305
      Control Set Loc hDlg, %IDC_BorderA,160,550
      Control Set Loc hDlg, %IDC_LabelTeams,25,470
      Control Set Loc hDlg, %IDC_TeamList,180,455
      Control Set Loc hDlg, %IDC_LabelPlayers, 25,370
      Control Set Loc hDlg, %IDC_FaceList,120,355
      Control Set Loc hDlg, %IDC_Graphic, 0,590
   Else
      Dialog Set Client hDlg, w, 560
      Control Set Loc hDlg, %IDC_BorderB,-5000,-5000
      Control Set Loc hDlg, %IDC_BorderA,-5000,-5000
      Control Set Loc hDlg, %IDC_LabelTeams,-5000,-5000
      Control Set Loc  hDlg, %IDC_TeamList,-5000,-5000
      Control Set Loc hDlg, %IDC_LabelPlayers,-5000,-5000
      Control Set Loc hDlg, %IDC_FaceList,-5000,-5000
      Control Set Loc hDlg, %IDC_Graphic,0,310
   End If
   Dialog ReDraw hDlg
End Sub

Sub PrintDelayMessage
   Select Case GameStatus
      Case "WaitingForA"
         Control Set Text hWait, %IDW_Label, $CrLf + "Waiting for " + NameAText + $CrLf + Format$(DelayCount\60,"0") + ":" + Format$(DelayCount Mod 60,"00")
      Case "WaitingForB"
         Control Set Text hWait, %IDW_Label, $CrLf + "Waiting for " + NameBText + $CrLf + Format$(DelayCount\60,"0") + ":" + Format$(DelayCount Mod 60,"00")
      Case "WaitingForInning
         Control Set Text hWait, %IDW_Label, $CrLf + "Delay before the next " + PeriodName + $CrLf + Format$(DelayCount\60,"0") + ":" + Format$(DelayCount Mod 60,"00")
   End Select
End Sub

Function PeriodSequence() As String
   Select Case Periods
      Case 1 : Function = " first "
      Case 2 : Function = " second "
      Case 3 : Function = " third "
      Case 4 : Function = " fourth "
      Case 5 : Function = " fifth "
      Case 6 : Function = " sixth "
      Case 7 : Function = " seventh "
      Case 8 : Function = " eighth "
      Case 9 : Function = " nineth "
   End Select
End Function

Sub DisplayGameStatus
   Local temp$
   temp$ += "Game Status:" + $Tab + GameStatus + $CrLf
   temp$ += "AllowDelays:" + $Tab + Str$(AllowDelays) + $CrLf
   temp$ += "DelayCount:" + $Tab + Str$(DelayCount) + $CrLf
   temp$ += "MaxTime:" + $Tab + $Tab + Str$(MaxTime) + $CrLf
   temp$ += "SportName:" + $Tab + SportName + $CrLf
   temp$ += "Periods:" + $Tab + $Tab + Str$(Periods) + $CrLf
   temp$ += "PeriodsCount:" + $Tab + Str$(PeriodCount) + $CrLf
   temp$ += "NoSound" + $Tab + $Tab + Str$(NoSound) + $CrLf
   temp$ += "CurrentTimeA:" + $Tab + Str$(CurrentTimeA) + $CrLf
   temp$ += "CurrentTimeB:" + $Tab + Str$(CurrentTimeB) + $CrLf
   temp$ += $CrLf
   temp$ += "F4-SelectSport" + $CrLf
   temp$ += "F5-ClearHistory" + $CrLf
   temp$ += "F6-SetDelays" + $CrLf
   temp$ += "F7-NoSound" + $CrLf
   temp$ += "F8-ScoreSound" + $CrLf
   temp$ += "F9-AllowDelays" + $CrLf
   temp$ += "F10-GameStatus" + $CrLf
   MsgBox temp$, %MB_Ok + %MB_IconInformation, "Game Status"
End Sub

Sub BuildPlayerMRU(Flag As Long)   'Flag=1 means clear history except for current two names
   Local i,iResult As Long, temp$
   'Both players will share a common dropdown list of player names

   'get Current Player Names
   Control Get Text hDlg, %IDC_NameAText To NameAText
   Control Get Text hDlg, %IDC_NameBText To NameBText

   If Flag Then
      'clear history
      Reset History()
   Else
      'Remove Current Players from History Array
      For i = UBound(History) To 0 Step -1
         If LCase$(History(i)) = LCase$(NameAText) Then Array Delete History(i)
      Next i
      For i = UBound(History) To 0 Step -1
         If LCase$(History(i)) = LCase$(NameBText) Then Array Delete History(i)
      Next i
   End If

   'Add Players to History at top of array - Player A first then Player B
   If NameAText <> NameBText Then Array Insert History(0), NameBText
   Array Insert History(0), NameAText

   'RemoveDropDownItemsFromComboBoxes (not Reset because dont want to remove Text in EditBox
   For i = 1 To 10
      ComboBox Delete hdlg, %IDC_NameAText, 1
      ComboBox Delete hdlg, %IDC_NameBText, 1
   Next i

   'AddHistoryItemsToComboBoxes
   For i = 9 To 0 Step -1
      If Len(History(i)) Then
         ComboBox Insert hDlg, %IDC_NameAText, 1, History(i)
         ComboBox Insert hDlg, %IDC_NameBText, 1, History(i)
      End If
   Next i
End Sub

Sub HidePeriod
      Control Set Loc hDlg, %IDC_PeriodA, -5000, -5000
      Control Set Loc hDlg, %IDC_PeriodB, -5000, -5000
End Sub

Sub HighlightPeriod
   'Player1
   If Periods = 9 Then
      'baseball
      Control Set Loc hDlg, %IDC_PeriodA, 40+(PeriodCount*48),295
   Else
      Control Set Loc hDlg, %IDC_PeriodA, 45+(PeriodCount*65),295
   End If
   'Player2
   If Periods = 9 Then
      'baseball
      Control Set Loc hDlg, %IDC_PeriodB, 525+(PeriodCount*48),295
   Else
      Control Set Loc hDlg, %IDC_PeriodB, 525+(PeriodCount*65),295
   End If
End Sub
